#!/usr/bin/perl

$title = "WEBڡٱ祹ץ";
$dir   = "src";
$template_path = "$dir/template.html";
$list_path     = "$dir/menu.list";

#------------------------------------------#

opendir(DIR, $dir) or die();
foreach $fn_src (readdir(DIR)){
  next unless($fn_src =~ /(.+)\.src$/i);
  my $fn_html = $1;
  $fn_src = "$dir/$fn_src";
  my $content = read_file($fn_src);
  my $menu    = create_menu($fn_html);
  my $last_modified = last_modified($fn_src);

  open  OUT, ">$fn_html";
  print OUT apply_template(\$content, \$menu, \$last_modified);
  close OUT;
}

closedir(DIR);


sub read_file {
  my $ret;
  open IN, $_[0];
  $ret .= $_ while(<IN>);
  close IN;
  return $ret;
}


sub create_menu {
  my $ret;
  open ML, $list_path;
  for(;;){
    my $title = <ML>;
    my $fn = <ML>;
    chomp($title);
    chomp($fn);
    if($title =~ /^>(.+)/){
      $title = $1;
      if($_[0] eq $fn){
        $ret .= "<li><span class=\"menu_h_sub\">$title</span></li>\n";
      } else {
	$ret .= "<li><a href=\"$fn\" class=\"menu_d_sub\">$title</a></li>\n";
      }
    } else {
      if($_[0] eq $fn){
        $ret .= "<li><span class=\"menu_h\">$title</span></li>\n";
      } else {
	$ret .= "<li><a href=\"$fn\" class=\"menu_d\">$title</a></li>\n";
      }
    }
    $_ = <ML>;
    if(/^\+/){ next;}
    elsif (/^-/) {$ret .= "<hr />\n";}
    else {last;}
  }
  return $ret;
}


sub last_modified {
  my $ret;
#  die unless (-f $_[0]);
  my ($mtime) = (stat($_[0]))[9];
  my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($mtime);
  $ret = sprintf("%04d/%02d/%02d %02d:%02d", $year + 1900, $mon + 1, $mday, $hour, $min);
  return $ret;
}

sub apply_template {
  my $content = ${$_[0]};
  my $menu    = ${$_[1]};
  my $last_modified = ${$_[2]};
  my $ret;
  open IN, $template_path;
  foreach(<IN>){
    s/__TITLE__/$title/;
    s/__LAST_MODIFIED__/$last_modified/;
    s/__MENU__/$menu/;
    s/__CONTENT__/$content/;
    $ret .= $_;
  }
  return $ret;
}
